#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

const int NumParam  = 3;         // number of parameters
const int StringLen = 3;         // length of the input string
int       MaxValue  = 1;         // max decimal value of the string
//*******************************************************************

void PrintHelp(char *argv)
{
   cerr << "Usage : " << argv << " <input file> <output file> | [-h | -H | -help]" << endl;
}   

//******************************************************************

int CheckValue(char *pIstr) {  // returns decimal value of the input 
                               // string. Returns -1 if value is not valid
  int i;
       
  for ( i = 0; i < strlen(pIstr) ; i++) 
      if (! isdigit(pIstr[i]))    // decimal digits allowed only
         return -1;
       	 
  i = atoi(pIstr); 
 // cout << i  << " " << pIstr << '\n';
  if (i >= MaxValue)        
     return -1;
  
  return i;   

}

//******************************************************************

int transfer(char *input, char *output) {

  ifstream *pIfile = new ifstream;
  pIfile->open(input, ios::nocreate);  //open input file
  if (!*pIfile) {                      // can't open -> exit
     pIfile->close();
     delete pIfile;
     return 1;
  }
  ofstream *pOfile = new ofstream;     // create output file
  pOfile->open(output); 
  if (!*pOfile) {                      // can't create -> exit
     pOfile->close();
     delete pOfile;
     return 2;
  }      
  
  int  lStringLen = StringLen + 1;
  char *pIstr = new char[lStringLen];  // input string +  '\0'
  int  Oint;                           // output integer
  long Counter;                        // number of lines 
  long ErrorCounter = 0;
  int  i; 

  for (Counter = 1 ; pIfile->good() && (pIfile->peek() != EOF) ;){
       pIfile->get(pIstr,lStringLen,'\n');
       
       Oint = CheckValue(pIstr);     // check validity
       if (Oint != -1 && (pIfile->peek() == '\n')) {              // value OK
	  if (strcmp(pIstr,"")) {
	     *pOfile << (char)Oint;     // write output
             Counter++;
          }
       }	   
       else {
       	  cout << "\nWarning : " << input <<  " : (line " << Counter <<") : '" << pIstr << "' is an illegal input string \n";    
          ErrorCounter++;
	  //pIfile->ignore(1024,'\n');
       }
       pIfile->ignore(1024,'\n');	  
  }         
  pIfile->close();
  pOfile->close();
  
  cout << "\n" << Counter - 1 << " characters transferred with " << ErrorCounter <<  " errors \n\n"; 
  delete pIfile;
  delete pOfile;
  delete [] pIstr;
  return 0;
}


//******************************************************************

main(int argc, char *argv[]) {

  if ((argc <= 2) || (argc > 3)) {
     PrintHelp(argv[0]);
     return 0;
  }   
  int i;
  for (i = 1; i < argc; i++) {
      if (!(strcmp(argv[i],"-h")) || !(strcmp(argv[i],"-H")) || !(strcmp(argv[i],"-help"))){
         PrintHelp(argv[0]);
         return 0;
      }   
  }      
  int BinStrLen = 1;
  for (i = 0; i < StringLen; i++)
      BinStrLen *= 2;

  for (i = 0; i < BinStrLen; i++)
      MaxValue *= 2;
        
  int result;
 
  result = transfer(argv[1], argv[2]);
  if (result == 1) 
     cerr << "Can't find the input file '" << argv[1] << "'\n";
  if (result == 2)
     cerr << "Can't create the output file '" << argv[2] << "'\n";   
}
